diff --git a/savenkov_alexander_lab_3/README.md b/savenkov_alexander_lab_3/README.md
new file mode 100644
index 0000000..039959d
--- /dev/null
+++ b/savenkov_alexander_lab_3/README.md
@@ -0,0 +1,167 @@
+# Лабораторная работа №3 - REST API, Gateway и синхронный обмен между микросервисами
+
+Цель: изучение шаблона проектирования gateway, построения синхронного обмена между микросервисами и архитектурного стиля RESTful API.
+
+Задачи:
+
+Создать 2 микросервиса, реализующих CRUD на связанных сущностях.
+Реализовать механизм синхронного обмена сообщениями между микросервисами.
+Реализовать шлюз на основе прозрачного прокси-сервера nginx.
+
+# Создание микросервисов
+1-й микросервис - video-conferencing-application для сущности Приложение для видеоконференций
+2-й микросервис - webcam-application для сущности Веб-камера
+
+Сущность: Веб-камера (Webcam):
+1. УИД (Уникальный идентификатор): Уникальный номер или код, идентифицирующий конкретную веб-камеру.
+2. Модель (Model): Название и модель веб-камеры.
+3. Разрешение (Resolution): Максимальное разрешение видеозаписи, которое может предоставить веб-камера.
+4. Интерфейс (Interface): Тип интерфейса для подключения к компьютеру (USB, Wi-Fi и т.д.).
+5. УИД видеоконференции (subscriptionUuid): УИД видеоконференции, с которым данная веб-камера связана. Это поле устанавливает связь "1-ко-многим" между веб-камерой и приложением.
+6. Информация о видеоконференции (subscriptionInfo): Информация полученная по subscriptionUuid и УИД видеоконференций о приложении для видеоконференции. Хранит в себе информацию об Приложение для видеоконференций (Name, Supported Platforms, Maximum Participants)
+
+Сущность: Приложение для видеоконференций (Video Conferencing Application):
+1. УИД (Уникальный идентификатор): Уникальный номер или код, идентифицирующий конкретное приложение для видеоконференций.
+2. Название (Name): Название приложения для видеоконференций.
+3. Поддерживаемые платформы (Supported Platforms): Операционные системы и устройства, на которых работает приложение (Windows, macOS, iOS, Android и др.).
+4. Максимальное количество участников (Maximum Participants): Максимальное количество пользователей, которое может присоединиться к одной видеоконференции.
+
+Связь "1-ко-многим" между этими сущностями реализуется через поле "УИД приложения" в сущности "Веб-камера". Каждая веб-камера связывается с конкретным приложением для видеоконференций через УИД этого приложения, и это позволяет одному приложению быть связанным с несколькими веб-камерами.
+
+Вот примеры моделей для запросов:
+Пример модели "Приложение для видеоконференций" для списка:
+{
+ "uuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "Name": "Zoom",
+ "Supported Platforms": "Windows, macOS, iOS, Android",
+ "Maximum Participants": 500
+}
+Пример модели "Приложение для видеоконференций" для создания или изменения:
+{
+ "uuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "Name": " Zoom",
+ "Supported Platforms": "Windows, macOS, iOS, Android",
+ "Maximum Participants": 500
+}
+Пример модели "Веб-камера" для списка:
+{
+ "uuid": "8740d660-b251-4272-8535-be7ec3748d4b",
+ "Model": "Logitech C920",
+ "Resolution": "Full HD 1080p",
+ "Interface": "USB",
+ "subscriptionUuid": "8f036445-a5bd-401c-926e-840f9de795cd"
+}
+Пример модели "Веб-камера" для создания или изменения:
+{
+ "Model": " Logitech C920",
+ "Resolution": " Full HD 1080p ",
+ "Interface": "USB",
+ "subscriptionUuid": "8f036445-a5bd-401c-926e-840f9de795cd"
+}
+Пример модели "Веб-камера" для подробностей:
+{
+ "uuid": "8740d660-b251-4272-8535-be7ec3748d4b",
+ "Model": "Logitech C920",
+ "Resolution": "Full HD 1080p",
+ "Interface": "USB",
+ "subscriptionUuid": "8f036445-a5bd-401c-926e-840f9de795cd",
+ "subscriptionInfo": {
+ "Name": "Zoom",
+ "Supported Platforms": "Windows, macOS, iOS, Android",
+ "Maximum Participants": 500
+ }
+}
+
+
+
Структура 1-го микросервиса
+
+
+
+
Структура 2-го микросервиса
+
+
+- контроллеры для обработка запросов, дтошки для выбора что изображать в сваггере при запросах, модели для сущностей, репозитории для отправки данных, сервисы для бизнес-логики
+
+# Докер файлы, докер компоус, nginx
+
+
+
Докер файл для 1-го микросервиса
+
+
+
+
Докер файл для 2-го микросервиса
+
+
+-Использования базового образа, установка рабочий директории, копирования джар файла, экспорт порта, запуск приложения при запуске контейнера
+
+
Докер компоус
+
+
+-создания общей сети для всех сервисов, запуск образов сервисов, проброска портов, копирования конфигурационного файла nginx и запуск этого сервиса после запуска других сервисов
+
+
nginx
+
+
+установка количества одновремменных подключений, прослушка запросов по 80 порту, серверное имя локалхост, адрес для переадресации запросов по нему, url переадрусации
+
+
Скрин созданых образов
+
+
+
+
Скрин созданых контейнеров
+
+
+
+
Swagger 1-го микросервиса
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
Swagger 2-го микросервиса
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+
+# Видео
+
+Видео с разбором лабораторной работы - https://youtu.be/FpiSDxH4FSU
diff --git a/savenkov_alexander_lab_3/screens/img1.png b/savenkov_alexander_lab_3/screens/img1.png
new file mode 100644
index 0000000..d9457b8
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img1.png differ
diff --git a/savenkov_alexander_lab_3/screens/img10.png b/savenkov_alexander_lab_3/screens/img10.png
new file mode 100644
index 0000000..058f313
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img10.png differ
diff --git a/savenkov_alexander_lab_3/screens/img11.png b/savenkov_alexander_lab_3/screens/img11.png
new file mode 100644
index 0000000..a1f60ea
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img11.png differ
diff --git a/savenkov_alexander_lab_3/screens/img12.png b/savenkov_alexander_lab_3/screens/img12.png
new file mode 100644
index 0000000..dcc04ff
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img12.png differ
diff --git a/savenkov_alexander_lab_3/screens/img13.png b/savenkov_alexander_lab_3/screens/img13.png
new file mode 100644
index 0000000..faa9b03
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img13.png differ
diff --git a/savenkov_alexander_lab_3/screens/img14.png b/savenkov_alexander_lab_3/screens/img14.png
new file mode 100644
index 0000000..74ef0bc
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img14.png differ
diff --git a/savenkov_alexander_lab_3/screens/img15.png b/savenkov_alexander_lab_3/screens/img15.png
new file mode 100644
index 0000000..f867a1b
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img15.png differ
diff --git a/savenkov_alexander_lab_3/screens/img16.png b/savenkov_alexander_lab_3/screens/img16.png
new file mode 100644
index 0000000..01b73d6
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img16.png differ
diff --git a/savenkov_alexander_lab_3/screens/img17.png b/savenkov_alexander_lab_3/screens/img17.png
new file mode 100644
index 0000000..0820a8c
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img17.png differ
diff --git a/savenkov_alexander_lab_3/screens/img18.png b/savenkov_alexander_lab_3/screens/img18.png
new file mode 100644
index 0000000..ed8fa32
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img18.png differ
diff --git a/savenkov_alexander_lab_3/screens/img19.png b/savenkov_alexander_lab_3/screens/img19.png
new file mode 100644
index 0000000..471f95e
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img19.png differ
diff --git a/savenkov_alexander_lab_3/screens/img2.png b/savenkov_alexander_lab_3/screens/img2.png
new file mode 100644
index 0000000..bcb7c20
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img2.png differ
diff --git a/savenkov_alexander_lab_3/screens/img20.png b/savenkov_alexander_lab_3/screens/img20.png
new file mode 100644
index 0000000..e89ef10
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img20.png differ
diff --git a/savenkov_alexander_lab_3/screens/img21.png b/savenkov_alexander_lab_3/screens/img21.png
new file mode 100644
index 0000000..5ccb70b
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img21.png differ
diff --git a/savenkov_alexander_lab_3/screens/img22.png b/savenkov_alexander_lab_3/screens/img22.png
new file mode 100644
index 0000000..7e8551e
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img22.png differ
diff --git a/savenkov_alexander_lab_3/screens/img23.png b/savenkov_alexander_lab_3/screens/img23.png
new file mode 100644
index 0000000..dce7bba
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img23.png differ
diff --git a/savenkov_alexander_lab_3/screens/img24.png b/savenkov_alexander_lab_3/screens/img24.png
new file mode 100644
index 0000000..1d84322
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img24.png differ
diff --git a/savenkov_alexander_lab_3/screens/img3.png b/savenkov_alexander_lab_3/screens/img3.png
new file mode 100644
index 0000000..5f505a0
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img3.png differ
diff --git a/savenkov_alexander_lab_3/screens/img4.png b/savenkov_alexander_lab_3/screens/img4.png
new file mode 100644
index 0000000..43a82a9
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img4.png differ
diff --git a/savenkov_alexander_lab_3/screens/img5.png b/savenkov_alexander_lab_3/screens/img5.png
new file mode 100644
index 0000000..b85e418
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img5.png differ
diff --git a/savenkov_alexander_lab_3/screens/img6.png b/savenkov_alexander_lab_3/screens/img6.png
new file mode 100644
index 0000000..6e1a0e9
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img6.png differ
diff --git a/savenkov_alexander_lab_3/screens/img7.png b/savenkov_alexander_lab_3/screens/img7.png
new file mode 100644
index 0000000..17221b2
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img7.png differ
diff --git a/savenkov_alexander_lab_3/screens/img8.png b/savenkov_alexander_lab_3/screens/img8.png
new file mode 100644
index 0000000..8e92e49
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img8.png differ
diff --git a/savenkov_alexander_lab_3/screens/img9.png b/savenkov_alexander_lab_3/screens/img9.png
new file mode 100644
index 0000000..f10e95e
Binary files /dev/null and b/savenkov_alexander_lab_3/screens/img9.png differ
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/.gitignore b/savenkov_alexander_lab_3/video-conferencing-application/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.jar b/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..bf82ff0
Binary files /dev/null and b/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.properties b/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..ca5ab4b
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,18 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.8.7/apache-maven-3.8.7-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.1/maven-wrapper-3.1.1.jar
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/mvnw b/savenkov_alexander_lab_3/video-conferencing-application/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/mvnw.cmd b/savenkov_alexander_lab_3/video-conferencing-application/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/pom.xml b/savenkov_alexander_lab_3/video-conferencing-application/pom.xml
new file mode 100644
index 0000000..b113be0
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/pom.xml
@@ -0,0 +1,56 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.17
+
+
+ com.example
+ video-conferencing-application
+ 0.0.1-SNAPSHOT
+ video-conferencing-application
+ Demo project for Spring Boot
+
+ 17
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+ org.springdoc
+ springdoc-openapi-ui
+ 1.7.0
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/Dockerfile b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/Dockerfile
new file mode 100644
index 0000000..60d74f5
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/Dockerfile
@@ -0,0 +1,14 @@
+# Используем базовый образ с Java и средой выполнения Spring Boot
+FROM openjdk:17-jdk-slim
+
+# Устанавливаем рабочий каталог внутри контейнера
+WORKDIR /app
+
+# Копируем JAR-файл приложения в контейнер (предполагается, что JAR-файл находится в каталоге target/)
+COPY target/video-conferencing-application-0.0.1-SNAPSHOT.jar video-conferencing-application.jar
+
+# Экспонируем порт, на котором будет работать приложение
+EXPOSE 8099
+
+# Запускаем приложение при запуске контейнера
+CMD ["java", "-jar", "video-conferencing-application.jar"]
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/VideoConferencingApplication.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/VideoConferencingApplication.java
new file mode 100644
index 0000000..2799502
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/VideoConferencingApplication.java
@@ -0,0 +1,11 @@
+package com.example.videoconferencingapplication;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class VideoConferencingApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(VideoConferencingApplication.class, args);
+ }
+}
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/controller/VideoConferenceAppController.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/controller/VideoConferenceAppController.java
new file mode 100644
index 0000000..7ef743a
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/controller/VideoConferenceAppController.java
@@ -0,0 +1,57 @@
+package com.example.videoconferencingapplication.controller;
+
+import com.example.videoconferencingapplication.model.VideoConferenceApp;
+import com.example.videoconferencingapplication.model.VideoConferenceAppDTO;
+import com.example.videoconferencingapplication.service.VideoConferenceAppService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+@RestController
+@RequestMapping("/video-conferencing-application")
+public class VideoConferenceAppController {
+ private final VideoConferenceAppService appService;
+
+ @Autowired
+ public VideoConferenceAppController(VideoConferenceAppService appService) {
+ this.appService = appService;
+ }
+
+ @GetMapping("/")
+ public List getAllApps() {
+ return appService.getAllApps();
+ }
+
+ @GetMapping("/{uuid}")
+ public ResponseEntity getAppByUuid(@PathVariable String uuid) {
+ return appService.getAppByUuid(uuid)
+ .map(app -> ResponseEntity.ok().body(app))
+ .orElse(ResponseEntity.notFound().build());
+ }
+
+ @PostMapping("/")
+ public ResponseEntity createApp(@RequestBody VideoConferenceAppDTO appDTO) {
+ VideoConferenceApp createdApp = appService.createApp(appDTO);
+ return ResponseEntity.status(HttpStatus.CREATED).body(createdApp);
+ }
+
+ @PutMapping("/{uuid}")
+ public ResponseEntity updateApp(@PathVariable String uuid, @RequestBody VideoConferenceAppDTO appDTO) {
+ VideoConferenceApp updatedApp = appService.updateApp(uuid, appDTO);
+ if (updatedApp != null) {
+ return ResponseEntity.ok().body(updatedApp);
+ } else {
+ return ResponseEntity.notFound().build();
+ }
+ }
+
+ @DeleteMapping("/{uuid}")
+ public ResponseEntity deleteApp(@PathVariable String uuid) {
+ boolean deleted = appService.deleteApp(uuid);
+ return deleted ? ResponseEntity.noContent().build() : ResponseEntity.notFound().build();
+ }
+}
+
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceApp.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceApp.java
new file mode 100644
index 0000000..5bfe006
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceApp.java
@@ -0,0 +1,73 @@
+package com.example.videoconferencingapplication.model;
+
+import javax.persistence.Entity;
+import javax.persistence.GeneratedValue;
+import javax.persistence.GenerationType;
+import javax.persistence.Id;
+import javax.persistence.Table;
+
+@Entity
+@Table(name = "video_conference_app")
+public class VideoConferenceApp {
+ @Id
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+ private String uuid;
+ private String name;
+ private String supportedPlatforms;
+ private int maximumParticipants;
+
+ // Конструктор по умолчанию
+ public VideoConferenceApp() {
+ }
+
+ // Конструктор для создания объекта с параметрами
+ public VideoConferenceApp(String uuid, String name, String supportedPlatforms, int maximumParticipants) {
+ this.uuid = uuid;
+ this.name = name;
+ this.supportedPlatforms = supportedPlatforms;
+ this.maximumParticipants = maximumParticipants;
+ }
+
+ // Геттеры и сеттеры для полей
+ public Long getId() {
+ return id;
+ }
+
+ public void setId(Long id) {
+ this.id = id;
+ }
+
+ public String getUuid() {
+ return uuid;
+ }
+
+ public void setUuid(String uuid) {
+ this.uuid = uuid;
+ }
+
+ public String getName() {
+ return name;
+ }
+
+ public void setName(String name) {
+ this.name = name;
+ }
+
+ public String getSupportedPlatforms() {
+ return supportedPlatforms;
+ }
+
+ public void setSupportedPlatforms(String supportedPlatforms) {
+ this.supportedPlatforms = supportedPlatforms;
+ }
+
+ public int getMaximumParticipants() {
+ return maximumParticipants;
+ }
+
+ public void setMaximumParticipants(int maximumParticipants) {
+ this.maximumParticipants = maximumParticipants;
+ }
+}
+
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceAppDTO.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceAppDTO.java
new file mode 100644
index 0000000..6dfde2b
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/model/VideoConferenceAppDTO.java
@@ -0,0 +1,53 @@
+package com.example.videoconferencingapplication.model;
+
+public class VideoConferenceAppDTO {
+ private String uuid;
+ private String name;
+ private String supportedPlatforms;
+ private int maximumParticipants;
+
+ // Конструктор по умолчанию
+ public VideoConferenceAppDTO() {
+ }
+
+ // Конструктор для создания объекта с параметрами
+ public VideoConferenceAppDTO(String uuid, String name, String supportedPlatforms, int maximumParticipants) {
+ this.uuid = uuid;
+ this.name = name;
+ this.supportedPlatforms = supportedPlatforms;
+ this.maximumParticipants = maximumParticipants;
+ }
+
+ // Геттеры и сеттеры для полей
+ public String getUuid() {
+ return uuid;
+ }
+
+ public void setUuid(String uuid) {
+ this.uuid = uuid;
+ }
+
+ public String getName() {
+ return name;
+ }
+
+ public void setName(String name) {
+ this.name = name;
+ }
+
+ public String getSupportedPlatforms() {
+ return supportedPlatforms;
+ }
+
+ public void setSupportedPlatforms(String supportedPlatforms) {
+ this.supportedPlatforms = supportedPlatforms;
+ }
+
+ public int getMaximumParticipants() {
+ return maximumParticipants;
+ }
+
+ public void setMaximumParticipants(int maximumParticipants) {
+ this.maximumParticipants = maximumParticipants;
+ }
+}
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/repository/VideoConferenceAppRepository.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/repository/VideoConferenceAppRepository.java
new file mode 100644
index 0000000..b635e0b
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/repository/VideoConferenceAppRepository.java
@@ -0,0 +1,13 @@
+package com.example.videoconferencingapplication.repository;
+
+import com.example.videoconferencingapplication.model.VideoConferenceApp;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
+import java.util.Optional;
+
+@Repository
+public interface VideoConferenceAppRepository extends JpaRepository {
+ Optional findByUuid(String uuid);
+}
+
+
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/service/VideoConferenceAppService.java b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/service/VideoConferenceAppService.java
new file mode 100644
index 0000000..e782fb6
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/java/com/example/videoconferencingapplication/service/VideoConferenceAppService.java
@@ -0,0 +1,64 @@
+package com.example.videoconferencingapplication.service;
+
+import com.example.videoconferencingapplication.model.VideoConferenceApp;
+import com.example.videoconferencingapplication.model.VideoConferenceAppDTO;
+import com.example.videoconferencingapplication.repository.VideoConferenceAppRepository;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.stereotype.Service;
+import org.springframework.transaction.annotation.Transactional;
+import java.util.List;
+import java.util.Optional;
+
+@Service
+public class VideoConferenceAppService {
+ private final VideoConferenceAppRepository appRepository;
+
+ @Autowired
+ public VideoConferenceAppService(VideoConferenceAppRepository appRepository) {
+ this.appRepository = appRepository;
+ }
+
+ @Transactional
+ public List getAllApps() {
+ return appRepository.findAll();
+ }
+
+ @Transactional
+ public Optional getAppByUuid(String uuid) {
+ return appRepository.findByUuid(uuid);
+ }
+
+ @Transactional
+ public VideoConferenceApp createApp(VideoConferenceAppDTO appDTO) {
+ VideoConferenceApp app = new VideoConferenceApp();
+ app.setUuid(appDTO.getUuid());
+ app.setName(appDTO.getName());
+ app.setSupportedPlatforms(appDTO.getSupportedPlatforms());
+ app.setMaximumParticipants(appDTO.getMaximumParticipants());
+ return appRepository.save(app);
+ }
+
+ @Transactional
+ public VideoConferenceApp updateApp(String uuid, VideoConferenceAppDTO appDTO) {
+ Optional existingApp = appRepository.findByUuid(uuid);
+ if (existingApp.isPresent()) {
+ VideoConferenceApp app = existingApp.get();
+ app.setName(appDTO.getName());
+ app.setSupportedPlatforms(appDTO.getSupportedPlatforms());
+ app.setMaximumParticipants(appDTO.getMaximumParticipants());
+ return appRepository.save(app);
+ }
+ return null;
+ }
+
+ @Transactional
+ public boolean deleteApp(String uuid) {
+ Optional existingApp = appRepository.findByUuid(uuid);
+ if (existingApp.isPresent()) {
+ appRepository.delete(existingApp.get());
+ return true;
+ }
+ return false;
+ }
+}
+
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/main/resources/application.properties b/savenkov_alexander_lab_3/video-conferencing-application/src/main/resources/application.properties
new file mode 100644
index 0000000..e51fdaa
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/main/resources/application.properties
@@ -0,0 +1,8 @@
+spring.datasource.url=jdbc:h2:mem:testdb
+spring.datasource.driverClassName=org.h2.Driver
+spring.datasource.username=sa
+spring.datasource.password=password
+spring.jpa.hibernate.ddl-auto=update
+spring.h2.console.enabled=true
+
+server.port=8099
diff --git a/savenkov_alexander_lab_3/video-conferencing-application/src/test/java/com/example/videoconferencingapplication/VideoConferencingApplicationTests.java b/savenkov_alexander_lab_3/video-conferencing-application/src/test/java/com/example/videoconferencingapplication/VideoConferencingApplicationTests.java
new file mode 100644
index 0000000..e995d12
--- /dev/null
+++ b/savenkov_alexander_lab_3/video-conferencing-application/src/test/java/com/example/videoconferencingapplication/VideoConferencingApplicationTests.java
@@ -0,0 +1,13 @@
+package com.example.videoconferencingapplication;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class VideoConferencingApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}
diff --git a/savenkov_alexander_lab_3/webcam-application/.gitignore b/savenkov_alexander_lab_3/webcam-application/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.jar b/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..bf82ff0
Binary files /dev/null and b/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.properties b/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..ca5ab4b
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,18 @@
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.8.7/apache-maven-3.8.7-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.1/maven-wrapper-3.1.1.jar
diff --git a/savenkov_alexander_lab_3/webcam-application/mvnw b/savenkov_alexander_lab_3/webcam-application/mvnw
new file mode 100644
index 0000000..8a8fb22
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/mvnw
@@ -0,0 +1,316 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /usr/local/etc/mavenrc ] ; then
+ . /usr/local/etc/mavenrc
+ fi
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="`/usr/libexec/java_home`"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`\\unset -f command; \\command -v java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]
+ then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=`cd "$wdir/.."; pwd`
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+BASE_DIR=`find_maven_basedir "$(pwd)"`
+if [ -z "$BASE_DIR" ]; then
+ exit 1;
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in (wrapperUrl) jarUrl="$value"; break ;;
+ esac
+ done < "$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=`cygpath --path --windows "$wrapperJarPath"`
+ fi
+
+ if command -v wget > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath" || rm -f "$wrapperJarPath"
+ fi
+ elif command -v curl > /dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=`cygpath --path --windows "$javaClass"`
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=`cygpath --path --windows "$MAVEN_PROJECTBASEDIR"`
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ $MAVEN_DEBUG_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" \
+ "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/savenkov_alexander_lab_3/webcam-application/mvnw.cmd b/savenkov_alexander_lab_3/webcam-application/mvnw.cmd
new file mode 100644
index 0000000..1d8ab01
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/mvnw.cmd
@@ -0,0 +1,188 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_pre.bat" call "%USERPROFILE%\mavenrc_pre.bat" %*
+if exist "%USERPROFILE%\mavenrc_pre.cmd" call "%USERPROFILE%\mavenrc_pre.cmd" %*
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+
+FOR /F "usebackq tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/org/apache/maven/wrapper/maven-wrapper/3.1.0/maven-wrapper-3.1.0.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% ^
+ %JVM_CONFIG_MAVEN_PROPS% ^
+ %MAVEN_OPTS% ^
+ %MAVEN_DEBUG_OPTS% ^
+ -classpath %WRAPPER_JAR% ^
+ "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" ^
+ %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%"=="" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%USERPROFILE%\mavenrc_post.bat" call "%USERPROFILE%\mavenrc_post.bat"
+if exist "%USERPROFILE%\mavenrc_post.cmd" call "%USERPROFILE%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%"=="on" pause
+
+if "%MAVEN_TERMINATE_CMD%"=="on" exit %ERROR_CODE%
+
+cmd /C exit /B %ERROR_CODE%
diff --git a/savenkov_alexander_lab_3/webcam-application/pom.xml b/savenkov_alexander_lab_3/webcam-application/pom.xml
new file mode 100644
index 0000000..761c9f8
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/pom.xml
@@ -0,0 +1,60 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.7.17
+
+
+ com.example
+ webcam-application
+ 0.0.1-SNAPSHOT
+ webcam-application
+ Demo project for Spring Boot
+
+ 17
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ com.h2database
+ h2
+ runtime
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springdoc
+ springdoc-openapi-ui
+ 1.7.0
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/Dockerfile b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/Dockerfile
new file mode 100644
index 0000000..28fcbd2
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/Dockerfile
@@ -0,0 +1,14 @@
+# Используем базовый образ с Java и средой выполнения Spring Boot
+FROM openjdk:17-jdk-slim
+
+# Устанавливаем рабочий каталог внутри контейнера
+WORKDIR /app
+
+# Копируем JAR-файл приложения в контейнер (предполагается, что JAR-файл находится в каталоге target/)
+COPY target/webcam-application-0.0.1-SNAPSHOT.jar webcam-application.jar
+
+# Экспонируем порт, на котором будет работать приложение
+EXPOSE 8090
+
+# Запускаем приложение при запуске контейнера
+CMD ["java", "-jar", "webcam-application.jar"]
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/WebcamApplication.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/WebcamApplication.java
new file mode 100644
index 0000000..e41c81c
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/WebcamApplication.java
@@ -0,0 +1,18 @@
+package com.example.webcamapplication;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.context.annotation.Bean;
+import org.springframework.web.client.RestTemplate;
+
+@SpringBootApplication
+public class WebcamApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(WebcamApplication.class, args);
+ }
+
+ @Bean
+ public RestTemplate restTemplate() {
+ return new RestTemplate();
+ }
+}
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/controller/WebcamController.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/controller/WebcamController.java
new file mode 100644
index 0000000..f7fbf55
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/controller/WebcamController.java
@@ -0,0 +1,61 @@
+package com.example.webcamapplication.controller;
+
+import com.example.webcamapplication.dto.WebcamCreateUpdateDTO;
+import com.example.webcamapplication.dto.WebcamDTO;
+import com.example.webcamapplication.dto.WebcamDetailDTO;
+import com.example.webcamapplication.service.WebcamService;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.http.ResponseEntity;
+import org.springframework.web.bind.annotation.*;
+
+import java.util.List;
+
+@RestController
+@RequestMapping("/webcam-application")
+public class WebcamController {
+ private final WebcamService webcamService;
+
+ @Autowired
+ public WebcamController(WebcamService webcamService) {
+ this.webcamService = webcamService;
+ }
+
+ @GetMapping("/")
+ public ResponseEntity> getWebcams() {
+ List webcams = webcamService.getAllWebcams();
+ return ResponseEntity.ok(webcams);
+ }
+
+ @GetMapping("/{uuid}")
+ public ResponseEntity getWebcam(@PathVariable String uuid) {
+ WebcamDetailDTO webcam = webcamService.getWebcamByUuid(uuid);
+ if (webcam != null) {
+ return ResponseEntity.ok(webcam);
+ }
+ return ResponseEntity.notFound().build();
+ }
+
+ @PostMapping("/")
+ public ResponseEntity createWebcam(@RequestBody WebcamCreateUpdateDTO createDTO) {
+ WebcamDetailDTO webcam = webcamService.createWebcam(createDTO);
+ return ResponseEntity.ok(webcam);
+ }
+
+ @PutMapping("/{uuid}")
+ public ResponseEntity updateWebcam(@PathVariable String uuid, @RequestBody WebcamCreateUpdateDTO updateDTO) {
+ WebcamDetailDTO webcam = webcamService.updateWebcam(uuid, updateDTO);
+ if (webcam != null) {
+ return ResponseEntity.ok(webcam);
+ }
+ return ResponseEntity.notFound().build();
+ }
+
+ @DeleteMapping("/{uuid}")
+ public ResponseEntity deleteWebcam(@PathVariable String uuid) {
+ boolean deleted = webcamService.deleteWebcam(uuid);
+ if (deleted) {
+ return ResponseEntity.ok().build();
+ }
+ return ResponseEntity.notFound().build();
+ }
+}
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/docker-compose.yml b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/docker-compose.yml
new file mode 100644
index 0000000..3c79d4a
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/docker-compose.yml
@@ -0,0 +1,31 @@
+version: '3'
+services:
+ video-conferencing-application:
+ image: fnaf459/microservice_1:1.0
+ ports:
+ - "8099:8099"
+ networks:
+ - network
+
+ webcam-application:
+ image: fnaf459/microservice_2:1.0
+ ports:
+ - "8090:8090"
+ networks:
+ - network
+
+ nginx:
+ image: nginx:latest
+ ports:
+ - "80:80"
+ networks:
+ - network
+ volumes:
+ - ./nginx.conf:/etc/nginx/nginx.conf
+ depends_on:
+ - video-conferencing-application
+ - webcam-application
+
+networks:
+ network:
+ driver: bridge
\ No newline at end of file
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamCreateUpdateDTO.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamCreateUpdateDTO.java
new file mode 100644
index 0000000..b8fcfc7
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamCreateUpdateDTO.java
@@ -0,0 +1,12 @@
+package com.example.webcamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class WebcamCreateUpdateDTO {
+ private String model;
+ private String resolution;
+ private String interfaceType;
+ private String subscriptionUuid;
+}
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDTO.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDTO.java
new file mode 100644
index 0000000..88967d7
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDTO.java
@@ -0,0 +1,14 @@
+package com.example.webcamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class WebcamDTO {
+ private String uuid;
+ private String model;
+ private String resolution;
+ private String interfaceType;
+ private String subscriptionUuid;
+}
+
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailDTO.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailDTO.java
new file mode 100644
index 0000000..8458d8f
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailDTO.java
@@ -0,0 +1,14 @@
+package com.example.webcamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class WebcamDetailDTO {
+ private String uuid;
+ private String model;
+ private String resolution;
+ private String interfaceType;
+ private String subscriptionUuid;
+ private WebcamDetailInfoDTO subscriptionInfo;
+}
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailInfoDTO.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailInfoDTO.java
new file mode 100644
index 0000000..b3d8114
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/dto/WebcamDetailInfoDTO.java
@@ -0,0 +1,11 @@
+package com.example.webcamapplication.dto;
+
+import lombok.Data;
+
+@Data
+public class WebcamDetailInfoDTO {
+ private String name;
+ private String supportedPlatforms;
+ private int maximumParticipants;
+}
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/model/Webcam.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/model/Webcam.java
new file mode 100644
index 0000000..7f73dc0
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/model/Webcam.java
@@ -0,0 +1,21 @@
+package com.example.webcamapplication.model;
+
+import lombok.Data;
+import javax.persistence.Entity;
+import javax.persistence.Id;
+import javax.persistence.GeneratedValue;
+import javax.persistence.GenerationType;
+
+@Entity
+@Data
+public class Webcam {
+ @Id
+ @GeneratedValue(strategy = GenerationType.IDENTITY)
+ private Long id;
+ private String uuid;
+ private String model;
+ private String resolution;
+ private String interfaceType;
+ private String subscriptionUuid;
+}
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/nginx.conf b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/nginx.conf
new file mode 100644
index 0000000..842ee03
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/nginx.conf
@@ -0,0 +1,19 @@
+events {
+ worker_connections 1024;
+}
+
+http {
+ server {
+ listen 80;
+ listen [::]:80;
+ server_name localhost;
+
+ location /video-conferencing-application/ {
+ proxy_pass http://video-conferencing-application:8099;
+ }
+
+ location /webcam-application/ {
+ proxy_pass http://webcam-application:8090;
+ }
+ }
+}
\ No newline at end of file
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/repository/WebcamRepository.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/repository/WebcamRepository.java
new file mode 100644
index 0000000..861e1ff
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/repository/WebcamRepository.java
@@ -0,0 +1,10 @@
+package com.example.webcamapplication.repository;
+
+import com.example.webcamapplication.model.Webcam;
+import org.springframework.data.jpa.repository.JpaRepository;
+import org.springframework.stereotype.Repository;
+
+@Repository
+public interface WebcamRepository extends JpaRepository {
+ Webcam findByUuid(String uuid);
+}
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/service/WebcamService.java b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/service/WebcamService.java
new file mode 100644
index 0000000..aa87201
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/java/com/example/webcamapplication/service/WebcamService.java
@@ -0,0 +1,116 @@
+package com.example.webcamapplication.service;
+
+import com.example.webcamapplication.dto.WebcamCreateUpdateDTO;
+import com.example.webcamapplication.dto.WebcamDTO;
+import com.example.webcamapplication.dto.WebcamDetailDTO;
+import com.example.webcamapplication.dto.WebcamDetailInfoDTO;
+import com.example.webcamapplication.model.Webcam;
+import com.example.webcamapplication.repository.WebcamRepository;
+import org.springframework.beans.factory.annotation.Autowired;
+import org.springframework.stereotype.Service;
+import org.springframework.web.client.RestTemplate;
+
+import java.util.List;
+import java.util.Random;
+import java.util.stream.Collectors;
+
+@Service
+public class WebcamService {
+ private final WebcamRepository webcamRepository;
+ private final RestTemplate restTemplate;
+
+ @Autowired
+ public WebcamService(WebcamRepository webcamRepository, RestTemplate restTemplate) {
+ this.webcamRepository = webcamRepository;
+ this.restTemplate = restTemplate;
+ }
+
+ public List getAllWebcams() {
+ List webcams = webcamRepository.findAll();
+ return webcams.stream()
+ .map(this::convertToWebcamDTO)
+ .collect(Collectors.toList());
+ }
+
+ public WebcamDetailDTO getWebcamByUuid(String uuid) {
+ Webcam webcam = webcamRepository.findByUuid(uuid);
+ if (webcam != null) {
+ return convertToWebcamDetailDTO(webcam);
+ }
+ return null;
+ }
+
+ public WebcamDetailDTO createWebcam(WebcamCreateUpdateDTO createDTO) {
+ Webcam webcam = new Webcam();
+ webcam.setUuid(createUUID()); // Генерируйте UUID или используйте другой метод
+ updateWebcamFromDTO(webcam, createDTO);
+ webcam = webcamRepository.save(webcam);
+ return convertToWebcamDetailDTO(webcam);
+ }
+
+ public WebcamDetailDTO updateWebcam(String uuid, WebcamCreateUpdateDTO updateDTO) {
+ Webcam webcam = webcamRepository.findByUuid(uuid);
+ if (webcam != null) {
+ updateWebcamFromDTO(webcam, updateDTO);
+ webcam = webcamRepository.save(webcam);
+ return convertToWebcamDetailDTO(webcam);
+ }
+ return null;
+ }
+
+ public boolean deleteWebcam(String uuid) {
+ Webcam webcam = webcamRepository.findByUuid(uuid);
+ if (webcam != null) {
+ webcamRepository.delete(webcam);
+ return true;
+ }
+ return false;
+ }
+
+ private WebcamDTO convertToWebcamDTO(Webcam webcam) {
+ WebcamDTO dto = new WebcamDTO();
+ dto.setUuid(webcam.getUuid());
+ dto.setModel(webcam.getModel());
+ dto.setResolution(webcam.getResolution());
+ dto.setInterfaceType(webcam.getInterfaceType());
+ dto.setSubscriptionUuid(webcam.getSubscriptionUuid());
+ return dto;
+ }
+
+ private WebcamDetailDTO convertToWebcamDetailDTO(Webcam webcam) {
+ WebcamDetailDTO detailDTO = new WebcamDetailDTO();
+ detailDTO.setUuid(webcam.getUuid());
+ detailDTO.setModel(webcam.getModel());
+ detailDTO.setResolution(webcam.getResolution());
+ detailDTO.setInterfaceType(webcam.getInterfaceType());
+ detailDTO.setSubscriptionUuid(webcam.getSubscriptionUuid());
+
+ WebcamDetailInfoDTO subscriptionInfo = getSubscriptionInfo(webcam.getSubscriptionUuid());
+ detailDTO.setSubscriptionInfo(subscriptionInfo);
+
+ return detailDTO;
+ }
+
+ private void updateWebcamFromDTO(Webcam webcam, WebcamCreateUpdateDTO dto) {
+ webcam.setModel(dto.getModel());
+ webcam.setResolution(dto.getResolution());
+ webcam.setInterfaceType(dto.getInterfaceType());
+ webcam.setSubscriptionUuid(dto.getSubscriptionUuid());
+ }
+
+ private String createUUID() {
+ Random random = new Random();
+ long mostSigBits = random.nextLong();
+ long leastSigBits = random.nextLong();
+ return String.format("%08x-%04x-%04x-%04x-%012x",
+ mostSigBits >>> 32, (mostSigBits >>> 16) & 0xFFFF, mostSigBits & 0xFFFF,
+ (leastSigBits >>> 16) & 0xFFFF, leastSigBits & 0xFFFF);
+ }
+
+
+ private WebcamDetailInfoDTO getSubscriptionInfo(String subscriptionUuid) {
+ String subscriptionInfoUrl = "http://nginx/video-conferencing-application/" + subscriptionUuid;
+ return restTemplate.getForObject(subscriptionInfoUrl, WebcamDetailInfoDTO.class);
+ }
+}
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/main/resources/application.properties b/savenkov_alexander_lab_3/webcam-application/src/main/resources/application.properties
new file mode 100644
index 0000000..b00d2a6
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/main/resources/application.properties
@@ -0,0 +1,9 @@
+spring.datasource.url=jdbc:h2:mem:testdb
+spring.datasource.driverClassName=org.h2.Driver
+spring.datasource.username=sa
+spring.datasource.password=password
+spring.jpa.hibernate.ddl-auto=update
+spring.h2.console.enabled=true
+
+server.port=8090
+
diff --git a/savenkov_alexander_lab_3/webcam-application/src/test/java/com/example/webcamapplication/WebcamApplicationTests.java b/savenkov_alexander_lab_3/webcam-application/src/test/java/com/example/webcamapplication/WebcamApplicationTests.java
new file mode 100644
index 0000000..bfa32f8
--- /dev/null
+++ b/savenkov_alexander_lab_3/webcam-application/src/test/java/com/example/webcamapplication/WebcamApplicationTests.java
@@ -0,0 +1,13 @@
+package com.example.webcamapplication;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class WebcamApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}